/*
When display a field modal ensure initialized to the current saved value which could be different to modal if previously changed
things in modal but then cancelled changes rather than saved so that the values stored in modal no longer match value of main form
*/
function initFieldsModal(userOption)
{
    var displayValue         = document.getElementById(userOption + "Span");
    var modalDisplayValue    = document.getElementById(userOption + "ModalSpan");
    var hiddenValue          = document.getElementById(userOption + "Hidden");
    var checkboxList         = document.getElementById(userOption + "CheckList");
    var checkboxes           = checkboxList.querySelectorAll('input[type=checkbox]');

    modalDisplayValue.innerHTML=displayValue.innerHTML;

    var selectedValuesArray = hiddenValue.value.split(",")
    for (var i = 0; i < checkboxes.length; i++) {
        if(selectedValuesArray.includes(checkboxes[i].id)) {
            checkboxes[i].checked=true;
        }
        else {
            checkboxes[i].checked=false;
        }
    }
}

/*
When save changes to a fields modal the fields badged list and hidden value list are updated
*/
function saveList(userOption)
{
   var displayValue    = document.getElementById(userOption + "Span");
   var hiddenValue     = document.getElementById(userOption + "Hidden");

    var checkboxList   = document.getElementById(userOption + "CheckList");
    var checkboxes = checkboxList.querySelectorAll('input[type=checkbox]');

   var hidden = "";
   displayValue.innerHTML="";

   for (var i = 0; i < checkboxes.length; i++) {
        if(checkboxes[i].checked)
        {
            var span=document.createElement("span");
            span.innerHTML=checkboxes[i].value;
            span.className = ' badge badge-warning ml-1';
            displayValue.appendChild(span);
            hidden+=checkboxes[i].id;
            hidden+=",";
        }
   }
   hiddenValue.value=hidden;
}

/*
When user has modified a checkbox in fields modal update the badge display in the modal
*/
function fieldCheckboxChanged(userOption)
{
    var displayValue    = document.getElementById(userOption + "ModalSpan");
    var checkboxList   = document.getElementById(userOption + "CheckList");
    var checkboxes = checkboxList.querySelectorAll('input[type=checkbox]');

    displayValue.innerHTML="";

    for (var i = 0; i < checkboxes.length; i++) {
        if(checkboxes[i].checked)
        {
            var span=document.createElement("span");
            span.innerHTML=checkboxes[i].value;
            span.className = ' badge badge-warning ml-1';
            displayValue.appendChild(span);
        }
    }
}

/*
Select all fields in the fields modal
*/
function modalFieldsSelect(userOption)
{
    var displayValue    = document.getElementById(userOption + "ModalSpan");
    var checkboxList   = document.getElementById(userOption + "CheckList");
    var checkboxes = checkboxList.querySelectorAll('input[type=checkbox]');

    displayValue.innerHTML="";
    for (var i = 0; i < checkboxes.length; i++) {
        checkboxes[i].checked=true;
        var span=document.createElement("span");
        span.innerHTML=checkboxes[i].value;
        span.className = ' badge badge-warning ml-1';
        displayValue.appendChild(span);
    }
}

/*
Deselect all fields in the fields modal
*/
function modalFieldsDeselect(userOption)
{
    var displayValue    = document.getElementById(userOption + "ModalSpan");
    var checkboxList   = document.getElementById(userOption + "CheckList");
    var checkboxes = checkboxList.querySelectorAll('input[type=checkbox]');

    for (var i = 0; i < checkboxes.length; i++) {
        checkboxes[i].checked=false;
    }
    displayValue.innerHTML="";
}

